package go;
import java.util.*;

/**
 * @author  emi
 */
public class Cerco{
	/**
	 * @uml.property  name="amo"
	 */
	private int amo;
	/**
	 * @uml.property  name="listaCruces"
	 */
	private ArrayList<Cruce> listaCruces;
	/**
	 * @uml.property  name="libertades"
	 */
	private int libertades;
	private boolean tratado;
	public Cerco(Ficha f){
		this.amo=f.getColorFicha();
		this.listaCruces=new ArrayList<Cruce>();
		this.listaCruces.add(f.getCruce());
		this.libertades=4;
		this.tratado=false;
	}
	public Cerco(Ficha f,int libertades){
		this.amo=f.getColorFicha();
		this.listaCruces=new ArrayList<Cruce>();
		this.listaCruces.add(f.getCruce());
		this.libertades=libertades;
		this.tratado=false;
	}
	
// 	Hecho por mi: constructor para crear cerco a partir de cerco, es decir, copiaCerco
	//VAMOS A HACER COPIA DE CERCO
	public Cerco(Cerco c){
		//System.out.println("CUANDO ENTRA AL CONSTRUCTOR el los cruces del cerco son" + c.getListaCruces());
		this.amo=c.getAmo();
		this.listaCruces=new ArrayList<Cruce>();
		
		
		//EL FALLO ERA QUE EN VEZ DE C LE PASABA THIS
		Iterator<Cruce>i=c.getListaCruces().iterator();
		while(i.hasNext()){
			Cruce cruce=i.next();
			Cruce prueba= new Cruce(cruce);
			this.listaCruces.add(prueba);
		}
		this.libertades=c.getLibertades();
		this.tratado=false;//?????????
	}
	
	
	
	/**
	 * @return
	 * @uml.property  name="amo"
	 */
	public int getAmo(){
		return this.amo;
	}
	/**
	 * @return
	 * @uml.property  name="listaCruces"
	 */
	public ArrayList<Cruce> getListaCruces(){
		return this.listaCruces;
	}
	public void setListaFichas(ArrayList<Cruce> lista){
		this.listaCruces=lista;
	}
	/**
	 * @return
	 * @uml.property  name="libertades"
	 */
	public int getLibertades(){
		return this.libertades;
	}
	/**
	 * @param nueva
	 * @uml.property  name="libertades"
	 */
	public void setLibertades(int nueva){
		this.libertades=nueva;
	}
	public void meteCruce(Ficha f){
		this.listaCruces.add(f.getCruce());
	}
	public void meteCruce(Cruce c){
		this.listaCruces.add(c);
	}
	public void marcar(){
		this.tratado=true;
	}
	public void desmarcar(){
		if(this.tratado)this.tratado=false;
	}
	public boolean marcado(){
		return this.tratado;
	}
	public String toString(){
		return "CERCO:{Amo: "+amo+" Lista de fichas: "+listaCruces+" Libertades: "+libertades+"}";
	}
	public boolean equals(Object o){
		if(!(o instanceof Cerco)) return false;
		Cerco c=(Cerco)o;
		if(this.getAmo()!=c.getAmo())return false;
		if(this.getLibertades()!=c.getLibertades())return false;
		if(!this.getListaCruces().equals((Object)c.getListaCruces()))return false;
		return true;
	}
}
