package go;

/**
 * @author  emi
 */
public class Ficha{
	/**
	 * @uml.property  name="pos"
	 * @uml.associationEnd  
	 */
	private Cruce pos;
	private int color;
	public Ficha(int f, int c, int color){
		this.pos=new Cruce(f,c);
		this.color=color;
	}
	public Ficha(Cruce pos, int color){
		this.pos=pos;
		this.color=color;
	}
	//YO
	public Ficha(Ficha f){
		this.pos=new Cruce(f.getFila(),f.getColumna());
		this.color=f.getColorFicha();
	}
	public int getFila(){
		return this.pos.getFila();
	}
	public int getColumna(){
		return this.pos.getColumna();
	}
	public Cruce getCruce(){
		return this.pos;
	}
	public int getColorFicha(){
		return this.color;
	}
	public boolean equals(Object o){
		if(!(o instanceof Ficha)){
			return false;
		}else{
			Ficha ficha=(Ficha)o;
			if(!this.pos.equals(ficha.getCruce())) return false;
			else return true;
		}
	}
	public String toString(){
		if(this.getColorFicha()==1) return "Ficha de color blanco en la posicion "+this.getCruce();
		return "Ficha de color negro en la posicion "+this.getCruce();
	}
}

